/*
 #-------------------------------------------------------------------------------
 #
 # Copyright 2008 - 2016 Joseph P. Zeh, Chiefwoodworker, Swamp Road Wood Works
 # All Rights Reserved
 #
 # THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
 # IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 # WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 #
 #-------------------------------------------------------------------------------
*/

var selected_line = null;

// assignAttributes - is the primary window where attributes can be assigned
// to milled components or other items.
function assignAttributes() {
   document.getElementById("assignAttributes").className = ("tabPicked");
   document.getElementById("assignAttributesDiv").style.zIndex = ("10");
   document.getElementById("assignAttributesDiv").style.display = ("block");
   document.getElementById("lists").className = ("tabInactive");
   document.getElementById("listsDiv").style.zIndex = ("1");
   document.getElementById("listsDiv").style.display = ("none");
   document.getElementById("columns").className = ("tabInactive");
   document.getElementById("columnsDiv").style.zIndex = ("1");
   document.getElementById("columnsDiv").style.display = ("none");
   document.getElementById("setup").className = ("tabInactive");
   document.getElementById("setupDiv").style.zIndex = ("1");
   document.getElementById("setupDiv").style.display = ("none");
}

// lists - provides the ability to create, modify, backup and restore
// the Rough Lumber, Dimensioned Lumber and Sheet Good lists.
function lists() {
   document.getElementById("lists").className = ("tabPicked");
   document.getElementById("listsDiv").style.zIndex = ("10");
   document.getElementById("listsDiv").style.display = ("block");
   document.getElementById("columns").className = ("tabInactive");
   document.getElementById("columnsDiv").style.zIndex = ("1");
   document.getElementById("columnsDiv").style.display = ("none");
   document.getElementById("setup").className = ("tabInactive");
   document.getElementById("setupDiv").style.zIndex = ("1");
   document.getElementById("setupDiv").style.display = ("none");
   document.getElementById("assignAttributes").className = ("tabInactive");
   document.getElementById("assignAttributesDiv").style.zIndex = ("1");
   document.getElementById("assignAttributesDiv").style.display = ("none");
}

// lists - provides the ability to create, modify, backup and restore
// the Rough Lumber, Dimensioned Lumber and Sheet Good lists.
function columns() {
   document.getElementById("columns").className = ("tabPicked");
   document.getElementById("columnsDiv").style.zIndex = ("10");
   document.getElementById("columnsDiv").style.display = ("block");
   document.getElementById("setup").className = ("tabInactive");
   document.getElementById("setupDiv").style.zIndex = ("1");
   document.getElementById("setupDiv").style.display = ("none");
   document.getElementById("assignAttributes").className = ("tabInactive");
   document.getElementById("assignAttributesDiv").style.zIndex = ("1");
   document.getElementById("assignAttributesDiv").style.display = ("none");
   document.getElementById("lists").className = ("tabInactive");
   document.getElementById("listsDiv").style.zIndex = ("1");
   document.getElementById("listsDiv").style.display = ("none");
}

// setup - provides the ability to save default attributes, <Info> and
// Description Field Format.
function setup() {
   document.getElementById("setup").className = ("tabPicked");
   document.getElementById("setupDiv").style.zIndex = ("10");
   document.getElementById("setupDiv").style.display = ("block");
   document.getElementById("assignAttributes").className = ("tabInactive");
   document.getElementById("assignAttributesDiv").style.zIndex = ("1");
   document.getElementById("assignAttributesDiv").style.display = ("none");
   document.getElementById("lists").className = ("tabInactive");
   document.getElementById("listsDiv").style.zIndex = ("1");
   document.getElementById("listsDiv").style.display = ("none");
   document.getElementById("columns").className = ("tabInactive");
   document.getElementById("columnsDiv").style.zIndex = ("1");
   document.getElementById("columnsDiv").style.display = ("none");
}

//setLegacyDisplay manages the state of the Legacy Mode Display checkbox
function setLegacyDisplay(id) {
  var checked = document.getElementById(id).checked;
  if (checked == true) {
    document.getElementById(id).value = "true";
  }
  else  {
    document.getElementById(id).value = "false";
  }
  window.location='skp:getLegacyDisplay';
}

//setSubAssemblyDisplay manages the state of the Sub-Assembly Display radio
//buttons
function setSubAssemblyDisplay(id) {
  switch (id) {
    case "bySubAssembly":
        document.getElementById("bySubAssembly").value = "true";
        document.getElementById("byLayerName").value = "false";
    break;
    case "byLayerName":
        document.getElementById("bySubAssembly").value = "false";
        document.getElementById("byLayerName").value = "true";
    break;
  }
  window.location='skp:getSubAssemblyDisplay';
}

//setDescriptionDisplay manages the state of the Description Display radio
//buttons
function setDescriptionDisplay(id) {
  switch (id) {
    case "sansComponentType":
        document.getElementById("sansComponentType").value = "true";
        document.getElementById("withComponentType").value = "false";
    break;
    case "withComponentType":
        document.getElementById("sansComponentType").value = "false";
        document.getElementById("withComponentType").value = "true";
    break;
  }
  window.location='skp:getDescriptionDisplay';
}

//setCutlistBridgeNumberingDisplay manages the state of the CutList Bridge
// Numbering Display radio buttons
function setCutlistBridgeNumberingDisplay(id) {
  switch (id) {
    case "numerically":
        document.getElementById("numerically").value = "true";
        document.getElementById("alphabetically").value = "false";
    break;
    case "alphabetically":
        document.getElementById("numerically").value = "false";
        document.getElementById("alphabetically").value = "true";
    break;
  }
  window.location='skp:getCutlistBridgeNumberingDisplay';
}

//setInfoDisplay manages the state of the Info Display radio
//buttons
function setInfoDisplay(id) {
  switch (id) {
    case "noDimensions":
        document.getElementById("noDimensions").value = "true";
        document.getElementById("oversize").value = "false";
        document.getElementById("as_drawn").value = "false";
    break;
    case "oversize":
        document.getElementById("noDimensions").value = "false";
        document.getElementById("oversize").value = "true";
        document.getElementById("as_drawn").value = "false";
    break;
    case "as_drawn":
        document.getElementById("noDimensions").value = "false";
        document.getElementById("oversize").value = "false";
        document.getElementById("as_drawn").value = "true";
    break;
  }
  window.location='skp:getInfoDisplay';
}

//setComponentNumberingDisplay manages the state of the Component Numbering
// Display radio buttons
function setComponentNumberingDisplay(id) {
  switch (id) {
    case "user":
      document.getElementById("user").value = "true";
      document.getElementById("cutlist_bridge").value = "false";
      document.getElementById("cabwriter").value = "false";
    break;
    case "cutlist_bridge":
      document.getElementById("user").value = "false";
      document.getElementById("cutlist_bridge").value = "true";
      document.getElementById("cabwriter").value = "false";
    break;
    case "cabwriter":
      document.getElementById("user").value = "false";
      document.getElementById("cutlist_bridge").value = "false";
      document.getElementById("cabwriter").value = "true";
    break;
  }
  window.location='skp:getComponentNumberingDisplay';
}

// setFieldChange - whenever the user changes an input setFieldChange ensures
// its associated value is updated and that other affected inputs are
// synchronized i.e. changed appropriately.
function setFieldChange(id, value)  {
  var checked = document.getElementById(id).checked;
  if ((checked == false)&&(value == "Yes")) {
    value = "No";
    setField(id, value);
  }
  if ((checked == true)&&(value == "No")) {
    value = "Yes";
    setField(id, value);
  }
  if ((checked == false)&&(value == "true")) {
    value = "false";
    setField(id, value);
  }
  if ((checked == true)&&(value == "false")) {
    value = "true";
    setField(id, value);
  }
  handleCallback('saveAttributes')
}

// setField - accepts id and value as arguments. The id argument is used as an
// element id whose value is set to the value argument. Setting a field may
// result in other fields changing as appropriate.
function setField(id, value)  {
  switch (id) {
    case "milledParts":
      if (value == "true")  {
        enableMilledParts();
        document.getElementById("otherItems").value = "false";
        document.getElementById("otherItems").checked = false;
        document.getElementById("item").value = "";
        document.getElementById("itemCell").style.visibility = "hidden";
        document.getElementById("cabinetMode").disabled = false;
      }
      else  {
        document.getElementById("milledParts").value = "false";
        document.getElementById("otherItems").value = "true";
        document.getElementById("otherItems").checked = true;
        document.getElementById("itemCell").style.visibility = "visible";
      }
    break;
    case "otherItems":
      if (value == "true")  {
        document.getElementById("otherItems").value = "true";
        document.getElementById("itemCell").style.visibility = "visible";
        disableMilledParts();
        document.getElementById("enableAutoSwap").value = "No";
        document.getElementById("enableAutoSwap").checked = false;
        document.getElementById("componentType").value = "";
        document.getElementById("oversizeWidthByCell").value = "";
        document.getElementById("oversizeLengthByCell").value = "";
        document.getElementById("oversizeThicknessByCell").value = "";
        document.getElementById("cabinetMode").value = "No";
        document.getElementById("cabinetMode").checked = false;
        document.getElementById("enableAutoSwapCell").style.visibility = 'hidden';
        document.getElementById("componentTypeCell").style.visibility = 'hidden';
        document.getElementById("oversizeWidthBy").value = "";
        document.getElementById("oversizeWidthByCell").style.visibility = 'hidden';
        document.getElementById("oversizeLengthBy").value = "";
        document.getElementById("oversizeLengthByCell").style.visibility = 'hidden';
        document.getElementById("oversizeThicknessBy").value = "";
        document.getElementById("oversizeThicknessByCell").style.visibility = 'hidden';
        document.getElementById("cabinetMode").disabled = true;
        document.getElementById("infoCell").style.visibility = 'visible';
     }
      else  {
        document.getElementById("otherItems").value = "false";
        document.getElementById("milledParts").value = "true";
        document.getElementById("milledParts").checked = true;
      }
    break;
    case "canRotate":
      if (value == "Yes")  {
        document.getElementById("canRotate").value = "Yes";
        document.getElementById("canRotate").checked = true;
      }
      else  {
        document.getElementById("canRotate").value = "No";
        document.getElementById("canRotate").checked = false;
      }
    break;
    case "swapLengthWidth":
      if (value == "Yes")  {
        document.getElementById("swapLengthWidth").value = "Yes";
        document.getElementById("enableAutoSwap").value = "No";
        document.getElementById("swapLengthWidth").checked = true;
        document.getElementById("enableAutoSwap").checked = false;
        document.getElementById("enableAutoSwap").disabled = true;
        document.getElementById("componentTypeCell").style.visibility = 'hidden';
        document.getElementById("componentType").value = "";
      }
      else  {
        document.getElementById("swapLengthWidth").value = "No";
        document.getElementById("swapLengthWidth").checked = false;
        document.getElementById("enableAutoSwap").disabled = false;
      }
    break;
    case "cabinetMode":
      if (value == "Yes")  {
        document.getElementById("cabinetMode").value = "Yes";
        document.getElementById("cabinetMode").checked = true;
        document.getElementById("info").value = "";
        document.getElementById("infoCell").style.visibility = 'hidden';
        document.getElementById("enableAutoSwapCell").style.visibility = 'visible';
        document.getElementById("oversizeWidthByCell").style.visibility = 'visible';
        document.getElementById("oversizeLengthByCell").style.visibility = 'visible';
        document.getElementById("oversizeThicknessByCell").style.visibility = 'visible';
      }
      else  {
        document.getElementById("cabinetMode").value = "No";
        document.getElementById("cabinetMode").checked = false;
        document.getElementById("enableAutoSwap").value = "No";
        document.getElementById("enableAutoSwap").checked = false;
        document.getElementById("infoCell").style.visibility = 'visible';
        document.getElementById("enableAutoSwapCell").style.visibility = 'hidden';
        document.getElementById("componentTypeCell").style.visibility = 'hidden';
        document.getElementById("oversizeWidthByCell").style.visibility = 'hidden';
        document.getElementById("oversizeWidthBy").value = "";
        document.getElementById("oversizeLengthByCell").style.visibility = 'hidden';
        document.getElementById("oversizeLengthBy").value = "";
        document.getElementById("oversizeThicknessByCell").style.visibility = 'hidden';
        document.getElementById("oversizeThicknessBy").value = "";
      }
    break;
    case "enableAutoSwap":
      if (value == "Yes")  {
        document.getElementById("enableAutoSwap").value = "Yes";
        document.getElementById("enableAutoSwap").checked = true;
        document.getElementById("componentTypeCell").style.visibility = 'visible';
      }
      else  {
        document.getElementById("enableAutoSwap").value = "No";
        document.getElementById("enableAutoSwap").checked = false;
        document.getElementById("componentType").value = "";
        document.getElementById("componentTypeCell").style.visibility = 'hidden';
      }
    break;
    case "materialName":
      var list = '<input name="materialName" id="materialName" type="text" value="" visible="false" class="inputTextStyle" />';
      writeMaterialName(list);
      document.getElementById(id).value = value;
    break;
    case "cabwriter_protected":
      if (value == "true")  {
        document.getElementById("cabwriter_protected").value = "true";
        document.getElementById("cabwriter_protected").checked = true;
      }
      else  {
        document.getElementById("cabwriter_protected").value = "false";
        document.getElementById("cabwriter_protected").checked = false;
      }
      break;
    default:
    document.getElementById(id).value = value;
  }
}

// disableMilledParts - clears all input fields in Milled Parts section, makes
// them invisible and disabled.
function disableMilledParts() {
  document.getElementById("milledParts").value = "false";
  document.getElementById("materialType").value = "";
  document.getElementById("materialTypeCell").style.visibility = "hidden";
  document.getElementById("materialNameCell").style.visibility = "hidden";
  document.getElementById("banding").value = "";
  document.getElementById("bandingCell").style.visibility = "hidden";
  document.getElementById("canRotate").value = "No";
  document.getElementById("canRotate").checked = false;
  document.getElementById("canRotate").disabled = true;
  document.getElementById("canRotateCell").style.visibility = 'hidden';
  document.getElementById("swapLengthWidth").value = "No";
  document.getElementById("swapLengthWidth").checked = false;
  document.getElementById("swapLengthWidth").disabled = true;
  document.getElementById("swapLengthWidthCell").style.visibility = 'hidden';
}

// enableMilledParts - clears all input fields in Milled Parts section, makes
// them visible and enabled.
function enableMilledParts() {
  document.getElementById("milledParts").value = "true";
  document.getElementById("materialTypeCell").style.visibility = "visible";
  document.getElementById("materialNameCell").style.visibility = "visible";
  document.getElementById("bandingCell").style.visibility = "visible";
  document.getElementById("canRotate").disabled = false;
  document.getElementById("canRotateCell").style.visibility = 'visible';
  document.getElementById("swapLengthWidth").disabled = false;
  document.getElementById("swapLengthWidthCell").style.visibility = 'visible';
}

// page_setup - calls the action callback onPageLoaded.
function page_setup()  {
  window.location='skp:onPageLoaded';  
}

// saveCompNumber - calls the action callback saveCompNumber.
function saveCompNumber()  {
  window.location='skp:saveCompNumber';
}

// saveAttributes - calls the action callback saveAttributes.
function saveAttributes()  {
  window.location='skp:saveAttributes';
}

// load_page() - calls the appropriate load_page_(page) action callback.
function load_page(page)  {
  selected_line = null;
  window.location='skp:' + 'load_page_' + page;
}

// writeMaterialName - creates a drop down list selected by the user following
// the Material Name: label.
function writeMaterialName(string)  {
  document.getElementById("materialListDiv").innerHTML = string;
}

// writeMaterialList - creates a drop down list selected by the user following
// the Remove: label.
//noinspection JSUnusedGlobalSymbols
function writeMaterialList(string)  {
  document.getElementById("theList").innerHTML = string;
}
// writeRawMaterialList - creates a drop down list for the selected
// Raw Materials page.
//noinspection JSUnusedGlobalSymbols
function writeRawMaterialList(string)  {
  document.getElementById("rawMaterialListDiv").innerHTML = string;
}

// write_line_items_table - writes a string to the current document which
// creates a blank table sufficiently wide and long for the selected material
// type and name.
//noinspection JSUnusedGlobalSymbols
function write_line_items_table(string)  {
  var empty_table = document.getElementById("body_div").innerHTML;
  var blank_table;
  blank_table = empty_table.replace(/<tbody>([\s\S]*?)<\/tbody>/i, string);
  document.getElementById("body_div").innerHTML = blank_table;
}

// line_selected - highlights the line containing the cell chosen and updates
// the Note text area.
function line_selected(id) {
  var str, count, i, cell;
  if (selected_line != null) {
    str = selected_line;
    count=document.getElementById(str).getElementsByTagName('td').length;
    document.getElementById(str).style.backgroundColor="#FFFFFF";
    for (i=1; i<=count; i++) {
      cell = "" + str + "_cell_" + i;
      document.getElementById(cell).style.backgroundColor="#FFFFFF";
    }
  }
  str=id.match(/^row_[1-9][0-9]*/g);
  count=document.getElementById(str).getElementsByTagName('td').length;
  document.getElementById(str).style.backgroundColor="#DBEAF9";
  for (i=1; i<=count; i++) {
    cell = "" + str + "_cell_" + i;
    document.getElementById(cell).style.backgroundColor="#DBEAF9";
  }
  selected_line = str;
  document.getElementById("selected_line").value = selected_line;
  window.location='skp:select_line';
}

// load_table - calls action callback load_table which populates the material
// table based on the material type and name.
function load_table() {
  window.location='skp:load_table';
}

// handleCallback - calls the action callback specified by the argument passed
// to it.
function handleCallback(callback)  {
  window.location='skp:' + callback;
}
